#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libvirt/libvirt.h>

int main(int argc, char *argv[])
{
  virConnect *conn;
  virDomain *dom;
  
  if (argc != 3)
    return -1;

  conn = virConnectOpen(NULL);
  if (!conn)
    return -1;

  if (strcmp(argv[1], "--id") == 0) {
    dom = virDomainLookupByID(conn, atoi(argv[2]));
  } else if (strcmp(argv[1], "--name") == 0) {
    dom = virDomainLookupByName(conn, argv[2]);
  }

  if (dom) {
    printf("%d\t %s\n", virDomainGetID(dom), virDomainGetName(dom));
    virDomainFree(dom);
  }
  virConnectClose(conn);

  return 0;
}
